﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Runtime.CompilerServices
Imports SelectedItemTest.Classes

Public Class AllTransports
    Implements INotifyPropertyChanged


    Public Sub New()
        AllTransports = New ObservableCollection(Of TransportBase)
        With AllTransports
            .Add(New Car() With {.Brand = "Volkswagen", .Cylinders = 4, .Model = "Arteon", .TopSpeed = 260, .Weight = 1616, .Equipment = New List(Of CarEquipment) From {
                 New CarEquipment() With {.Caption = "Automatische Distanzregelung ACC", .Description = "bis 210 km/h inkl. Umfeldbeobachtungssystem 'Front Assist' und adaptiver Geschwindigkeitsregelanlage"},
                                     New CarEquipment() With {.Caption = "Active Info Display", .Description = "Kombiinstrument in Form von einem TFT Display"},
                    New CarEquipment() With {.Caption = "ParkPilot", .Description = "akustische Warnsignale bei Hindernissen im Front- und Heckbereich"}}})
            .Add(New Car() With {.Brand = "Seat", .Cylinders = 3, .Model = "Ibiza", .TopSpeed = 185, .Weight = 1300, .Equipment = New List(Of CarEquipment) From {
                 New CarEquipment() With {.Caption = "LED Scheinwerfer", .Description = "Voll-LED Scheinwerfer"},
                                     New CarEquipment() With {.Caption = "Winterpaket", .Description = "Winterpaket inkl. Sitzheizung"},
                    New CarEquipment() With {.Caption = "ParkPilot", .Description = "akustische Warnsignale bei Hindernissen im Front- und Heckbereich"}}})
        End With


        SelectedTransport = AllTransports.First
    End Sub

    Private _allTransports As ObservableCollection(Of TransportBase)
    Public Property AllTransports() As ObservableCollection(Of TransportBase)
        Get
            Return _allTransports
        End Get
        Set(ByVal value As ObservableCollection(Of TransportBase))
            _allTransports = value
            RaisePropertyChanged()
        End Set
    End Property

    Private _selectedTransport As TransportBase

    Public Property SelectedTransport() As TransportBase
        Get
            Return _selectedTransport
        End Get
        Set(ByVal value As TransportBase)
            _selectedTransport = value
            RaisePropertyChanged()
        End Set
    End Property





    Protected Overridable Sub RaisePropertyChanged(<CallerMemberName> Optional ByVal prop As String = "")
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(prop))
    End Sub


    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
End Class
